"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var React = require("react");
var ReactDOM = require("react-dom");
var classBuilder_1 = require("./../../utilities/classBuilder");
var grid_1 = require('./../layout/grid');
var Dialog = (function (_super) {
    __extends(Dialog, _super);
    function Dialog() {
        _super.apply(this, arguments);
    }
    Dialog.prototype.closeClicked = function () {
        if (this.props.onClose) {
            this.props.onClose();
        }
        this.unmountPortalNode();
    };
    Dialog.prototype.scrollToTop = function () {
        this.dialogContentElement.scrollTop = 0;
    };
    Dialog.prototype.componentDidMount = function () {
        this.dialogContentElement = document.getElementById("dialog-content");
        this.appNode = document.getElementById(this.props.bodyId || "host");
        if (this.props.isOpen) {
            this.renderToPortal(this.renderDialog(this.props.children));
        }
    };
    Dialog.prototype.componentWillReceiveProps = function (newProps) {
        var open = newProps.isOpen;
        if (open && open != this.props.isOpen && this.props.onOpen) {
            this.props.onOpen();
        }
        if (open) {
            this.renderToPortal(this.renderDialog(newProps.children));
        }
        else {
        }
    };
    Dialog.prototype.renderToPortal = function (element) {
        var node = this.portalNode;
        if (node == null) {
            this.portalNode = node = document.createElement('div');
            this.portalNode.classList.add('dialog-layer');
            node.id = this.dialogId || "dialog-layer-" + Math.random();
            this.appNode.appendChild(node);
        }
        if (element === null) {
            element = React.DOM.noscript();
        }
        ReactDOM.unstable_renderSubtreeIntoContainer(this, element, node);
    };
    Dialog.prototype.componentWillUnmount = function () {
        this.unmountPortalNode();
    };
    Dialog.prototype.unmountPortalNode = function () {
        if (!this.portalNode) {
            return;
        }
        var unmounted = ReactDOM.unmountComponentAtNode(this.portalNode);
        if (unmounted) {
            document.getElementById(this.props.bodyId || "host").removeChild(this.portalNode);
        }
        delete this.portalNode;
        return unmounted;
    };
    Dialog.prototype.renderDialog = function (children) {
        var _this = this;
        var style = { width: this.props.width || "500px", height: this.props.height || "auto" };
        return (React.createElement(grid_1.Grid, {fillContainer: true}, React.createElement(grid_1.Row, null, React.createElement(grid_1.Col, {centerContent: "both", className: "dialog-layout-col"}, React.createElement("div", __assign({className: "dialog", style: style, role: "dialog", "aria-hidden": !this.props.isOpen, "aria-labelledby": this.props.title, "aria-describedby": this.props.subtitle}, this.props), React.createElement(grid_1.Grid, {fillContainer: true}, React.createElement(grid_1.Row, {className: classBuilder_1.classNames("dialog-header", classBuilder_1.cd("dialog-header-no-title", !this.props.title)), fixed: true}, React.createElement(grid_1.Col, {centerContent: { vertical: "center" }}, this.props.title &&
            React.createElement("div", {className: "flex-override"}, React.createElement("div", {className: "dialog-titles"}, this.props.title && React.createElement("div", {className: "dialog-title"}, this.props.title), this.props.subtitle && React.createElement("div", {className: "dialog-subtitle"}, this.props.subtitle)))), React.createElement(grid_1.Col, {fixed: true}, React.createElement("div", {className: "close-dialog-button", onClick: function () { return _this.props.onXClicked ? _this.props.onXClicked() : _this.closeClicked(); }}))), React.createElement(grid_1.SingleColumnRow, {id: "dialog-content", className: "dialog-content"}, React.createElement("div", null, children)), React.createElement(grid_1.SingleColumnRow, {className: "dialog-footer", fixed: true}, this.props.footerContent)))))));
    };
    Dialog.prototype.render = function () {
        return (React.createElement("noscript", null));
    };
    return Dialog;
}(React.Component));
exports.Dialog = Dialog;
